Estructuras de Control de Flujo
R
2018-05-21
1 Introduccin:Estructuras de control de flujo
2 Sentencias de bifurcacin:
  2.1 IF-ELSE
2.2 La estructura ifelse()
3 Bucles
3.1 Sentencia for
3.2 Sentencia WHILE
3.3 Sentencia repeat y break
3.4 Instruccin next
4 La funcin switch()
4.1 La expresin es numrica
4.2 La expresin es una cadena
5 La funcin scan()
6 Ejercicios
7 Notas

1 Introduccin:Estructuras de control de flujo
Las estructuras de control en R permiten controlar el flujo del programa de acuerdo a ciertas condiciones de ejecucin. Las estructuras de las que dispone R son las tpicas de los lenguajes de programacin:
  
  IF-ELSE
WHILE
REPEAT
BREAK
NEXT
FOR
SWITCH
2 Sentencias de bifurcacin:
  2.1 IF-ELSE
La sentencia if permite la ejecucin de una o ms sentencias en funcin de que se cumpla o no, una condicin. Hay dos versiones de la sentencia if, la ms simple tiene la siguiente sintaxis:
  
  if (condicin) {instrucciones  cuando es TRUE }
alt text
alt text

Ejemplo 1

x <- 6    # Nmero a comparar
if (x > 5) cat('El nmero es mayor que 5','\n')
## El nmero es mayor que 5
print('Fin')
## [1] "Fin"
x <- 4    # Nmero a comparar
if (x > 5) cat('El nmero es mayor que 5','\n')
print('Fin')
## [1] "Fin"
La forma ms completa de la sentencia if es,

if (condicin) {
  instrucciones  cuando es TRUE
} else {
  instrucciones cuando es FALSE
}
alt text
alt text

Ejemplo

Se puede ejecutar un if-else en una nica lnea. Compare estos dos cdigos,

# Cdigo 1
x <- 2
if (x >2) y <- 2*x else y <- 3*x
print(y)
## [1] 6
# Cdigo 2
x <- 2
if (x >2) {y <- 2*x
} else {y <- 3*x}
print(y)
## [1] 6
2.2 La estructura ifelse()
Hay una tercera forma de la estructura if . Es la sentencia ifelse() que es una forma vectorizada de la funcin if() else(). En el caso de trabajar con vectores es una opcin ms rpida que utilizar if else anidados.

Su sintaxis es,

ifelse(test, si, no)
donde test es una condicin lgica. Si se cumple el resultado es el valor si, en caso contrario no.

Ejemplo

# ifelse funcin vectorizada
x <- 1:5
x
## [1] 1 2 3 4 5
# ifelse realiza una comparacin con cada uno de los elemntos del objeto x. En este caso un vector
ifelse(x==1,"igual", ifelse(x>1,'mayor','menor'))
## [1] "igual" "mayor" "mayor" "mayor" "mayor"
3 Bucles
3.1 Sentencia for
La sentencia for permite repetir una serie de instrucciones un nmero determinado de veces. En R for es una forma genrica de iterar sobre una secuencia.

Sintaxis

for (variable in secuencia) {
  instrucciones
}
Ejemplo

1.- Presenta los 10 primero nmeros naturales

for(i in 1:10) {print(i)}  # La secuencia es 1:10
## [1] 1
## [1] 2
## [1] 3
## [1] 4
## [1] 5
## [1] 6
## [1] 7
## [1] 8
## [1] 9
## [1] 10
2.- Presentar los nprimeros nmeros naturales donde n es un valor que se introduce por teclado.

entrada <-readline('Introduce un nmero entero ')
n <- as.integer(entrada)
for(i in 1:n) {print(i)}  # La secuencia es 1:n
Observar que ocurre cuando se introduce un nmero real.

3.- Presenta los nmero impares entre 1 y n, donde n es un valor que se introduce por teclado

entrada <-readline('Introduce un nmero entero ')
n <- as.integer(entrada)
for(i in seq(1,n,2)) {print(i)}  # La secuencia es 1:n
4.- Dado un nmero entero, muestra las races cuadradas de los enteros impares entre 1 y el dato dato

# Dato n
n <- 34
for(i in seq(1,n,2)){
  raiz <- sqrt(i)
  print(raiz)
}
## [1] 1
## [1] 1.732051
## [1] 2.236068
## [1] 2.645751
## [1] 3
## [1] 3.316625
## [1] 3.605551
## [1] 3.872983
## [1] 4.123106
## [1] 4.358899
## [1] 4.582576
## [1] 4.795832
## [1] 5
## [1] 5.196152
## [1] 5.385165
## [1] 5.567764
## [1] 5.744563
Gracias a la vectorizacin en R se resolvera de la forma siguiente:
  
  n <- 34
raiz <- sqrt(seq(1,n,2))
print(raiz)
##  [1] 1.000000 1.732051 2.236068 2.645751 3.000000 3.316625 3.605551
##  [8] 3.872983 4.123106 4.358899 4.582576 4.795832 5.000000 5.196152
## [15] 5.385165 5.567764 5.744563
O de forma ms compacta

n <- 34
print(sqrt(seq(1,n,2)))
##  [1] 1.000000 1.732051 2.236068 2.645751 3.000000 3.316625 3.605551
##  [8] 3.872983 4.123106 4.358899 4.582576 4.795832 5.000000 5.196152
## [15] 5.385165 5.567764 5.744563
3.- Secuencia de Fibonacci

# Nmeros de Fibonacci

Fibonacci <- numeric(12)                 # Crea un vector fila de dimensin 12
Fibonacci[1] <- Fibonacci[2]<- 1           # Inicializa los dos primeros elementos
for (i in 3:12){                           # Contador i pertenece a la secuencia 3 hasta 12
  Fibonacci[i] <- Fibonacci[i-2]+Fibonacci[i-1]
}
print(Fibonacci)
##  [1]   1   1   2   3   5   8  13  21  34  55  89 144
2.- Suma de los elementos de un vector por medio de un bucle.

(x_list <- seq(1, 15, by=2))                       # Se define la secuencia
## [1]  1  3  5  7  9 11 13 15
sum_x <- 0
for (x in x_list) {
  sum_x <- sum_x + x
  cat("El elemento actual del bucle es", x, "\n")
  cat("El acumulado es", sum_x, "\n")
}
## El elemento actual del bucle es 1 
## El acumulado es 1 
## El elemento actual del bucle es 3 
## El acumulado es 4 
## El elemento actual del bucle es 5 
## El acumulado es 9 
## El elemento actual del bucle es 7 
## El acumulado es 16 
## El elemento actual del bucle es 9 
## El acumulado es 25 
## El elemento actual del bucle es 11 
## El acumulado es 36 
## El elemento actual del bucle es 13 
## El acumulado es 49 
## El elemento actual del bucle es 15 
## El acumulado es 64
3.- Factorial de un nmero

# Calculo del factorial de un nmero por medio de un bucle.
# Limpiar el espacio de trabajo
rm(list=ls())  # Elimina todos los objetos del espacio de trabajo.

# Dato
n <- 7
# Clculos
n_factorial <- 1
for (i in 1:n) {
  n_factorial <- n_factorial * i
}
# Salida
show(n_factorial)
## [1] 5040
4.- Estos tres bucles hacen lo mismo

x <- c("a", "b", "c", "d")
for(i in 1:4) {
  print(x[i])
}
## [1] "a"
## [1] "b"
## [1] "c"
## [1] "d"
for(i in seq_along(x)) {
  print(x[i])
}
## [1] "a"
## [1] "b"
## [1] "c"
## [1] "d"
for(letter in x) {
  print(letter)
}
## [1] "a"
## [1] "b"
## [1] "c"
## [1] "d"
for(i in 1:4) print(x[i])
## [1] "a"
## [1] "b"
## [1] "c"
## [1] "d"
5.- Los bucles pueden ser anidados

x <- matrix(1:6, 2, 3)
for(i in seq_len(nrow(x))) {
  for(j in seq_len(ncol(x))) {
    print(x[i, j])
  }
}
## [1] 1
## [1] 3
## [1] 5
## [1] 2
## [1] 4
## [1] 6
6.- Redimensionar un vector cuesta tiempo.

# Programa 1

system.time({
  n <- 10000
  x <- rep(0, n)
  for (i in 1:n) {
    x[i] <- 1
  }
})
# Programa 2

system.time({
  n <- 10000
  x <- 1
  for (i in 1:n) {
    x[i] <- 1
  }
})
#Programa 3

system.time({
  x <- rep(1,10000)
})
7.- Crea la siguiente matriz Este tipo de matrices se denominan tridiagonal.

##      [,1] [,2] [,3] [,4] [,5] [,6]
## [1,]    1   -2    1    0    0    0
## [2,]    0    1   -2    1    0    0
## [3,]    0    0    1   -2    1    0
## [4,]    0    0    0    1   -2    1
El siguiente cdigo es manifiestamente mejorable. Busca otro.

a <- matrix( ncol=6, nrow=4)

for(i in (1:4)){
  for(j in (1:6)){
    if(j==i) {a[i,j]<-1 
    }else if(j==(i+1)) {a[i,j]<- -2 
    }else if(j==(i+2)) {a[i,j]<-1 
    }else {a[i,j]<-0}
  }
}
a
8.- Criba de Eratstenes

Calcula los nmero primos por medio de la criba de Eratstenes.

# Peticin del nmero mayor

mayor <- scan(what=integer(0),nmax=1,multi.line = FALSE)
datos <- 1: mayor                           # Vector con todos los nmeros
# Se eliminan los multiplos de cada nmero
for (i in 2:mayor){
  if(datos[i] !=0 & 2*datos[i]<mayor) datos[seq(2*i, mayor,i)] <- 0
}
# Mostramos los nmeros primos
datos[datos!=0]
9.- Simular el lanzamiento de un dado.

Determinar la cantidad de lanzamientos hasta obtener un 5.

# Simular el lanzamiento de un dado.
# Determinar la cantidad de lanzamientos hasta obtener un 5.

set.seed(17)       # Inicializa el generador de nmeros pseudoaleatorios
n <- 200
for(i in 1:n){
  x <- floor(runif(1)*6)+1
  print(x)
  if(x==5){
    cat('El nmero de lanzamientos ha sido ',i,'\n')
    break}
}
## [1] 1
## [1] 6
## [1] 3
## [1] 5
## El nmero de lanzamientos ha sido  4
Esta solucin no parece la ms adecuada, primero porque un bucle for est pensado para recorrerlo entero y aunque la instruccin break resuelve el problema hay que buscar otras posibilidades, y en segundo lugar porque no hay garanta de obtener un 5 en la cantidad de lanzamientos especificados.

3.2 Sentencia WHILE
La sentencia while permite realizar un bucle sin saber a priori el nmero de veces que habr que repetir el conjunto de sentencias. Al principio del bucle se comprueba la condicin, si esta se cumple, se realiza el bucle. Al finalizar la ejecucin del cuerpo del bucle se vuelve al principio y se vuelve a comprobar la condicin, etc.

Sintaxis

while (expresin lgica) {
  conjunto de instrucciones
}
Si la condicin nunca se cumpliera, el bucle while se convierte en un bucle infinito.

Ejemplos

1.- Cuenta de 0 a 9.

cuenta <- 0
while(cuenta < 10) {
  print(cuenta)
  cuenta <- cuenta + 1
}
## [1] 0
## [1] 1
## [1] 2
## [1] 3
## [1] 4
## [1] 5
## [1] 6
## [1] 7
## [1] 8
## [1] 9
2.- Siguiendo con los nmeros de Fibonacci ahora se quiere obtener los nmeros de Fibonacci menores de 300.

# Nmeros de Fibonacci
Fib1 <- 1
Fib2 <- 1
Fibonacci <- c(Fib1, Fib2)
while (Fib2 < 300)
{
  Fibonacci <- c(Fibonacci, Fib2)
  viejoFib2 <- Fib2
  Fib2 <- Fib1 + Fib2
  Fib1 <- viejoFib2
}
print(Fibonacci)
##  [1]   1   1   1   2   3   5   8  13  21  34  55  89 144 233
3.- Puede haber ms de una condicin en un while, en ese caso las condiciones se evalan de izquierda a derecha.

z <- 5
while(z >= 3 & z <= 10) {
  print(z)
  coin <- rbinom(1, 1, 0.5)
  if(coin == 1) {        ## Paseo aleatorio
    z <- z + 1
  } else {
    z <- z - 1
  }
}
## [1] 5
## [1] 4
## [1] 5
## [1] 4
## [1] 3
## [1] 4
## [1] 3
4.- Simular el lanzamiento de un dado.

Determinar la cantidad de lanzamientos hasta obtener un 5.

# Simular el lanzamiento de un dado.
# Determinar la cantidad de lanzamientos hasta obtener un 5.
set.seed(1504)
n <- 0
x <- 0
while(x!= 5){
  x <- floor(runif(1)*6)+1
  n <- n+1
  print(n)
}
## [1] 1
## [1] 2
## [1] 3
## [1] 4
## [1] 5
## [1] 6
## [1] 7
## [1] 8
## [1] 9
## [1] 10
## [1] 11
## [1] 12
## [1] 13
## [1] 14
## [1] 15
5.- Dada una cantidad de bacterias, determine en que da excede al mximo si cada da se duplica la cantidad de bacterias.

# Datos
#   x - cantidad inicial de bacterias
#   m - mximo a alcanzar
#   d - da que se alcanza el mximo

# Crecimiento bacterias

x <- 5
m <- 2000
d <- 0

while(x < m){
  x <- 2*x
  d <- d +1
}
cat('Da ', d, '\n')
## Da  9
6.- Genere una secuencia de Ulam.

Dado un nmero entero, la secuencia de Ulam se genera segn la siguiente regla:
  x={x23x+1x parx impar
    
    # Secuencia de Ulam
    x <- 7L                    # Nmero entero positivo
    while(x!=1){
      if(x%%2 == 0) x <- x/2
      else          x <- 3*x+1
      show(x)
    }
    ## [1] 22
    ## [1] 11
    ## [1] 34
    ## [1] 17
    ## [1] 52
    ## [1] 26
    ## [1] 13
    ## [1] 40
    ## [1] 20
    ## [1] 10
    ## [1] 5
    ## [1] 16
    ## [1] 8
    ## [1] 4
    ## [1] 2
    ## [1] 1
    7.- Creciemiento de una colonia de bacterias Se desea encontrar el nmero de das en la poblacin de una colonai de bacterias llegar a un cierto valor Mmax. Sabemos que la poblacin se duplica cada dos das. Para encontrar el valor mximo usamos un ciclo Mientras. Dentro de este ciclo ussamos una condicin para saber si se alcanz el valor mximo. Finalmente, mostramos el nemro de das y la poblacin final de la colonia de bacteras.
    
    El algoritmo es el siguiente:
      
      Inicilizamos la pobalcin inicial de la bacteria a M0.
    Inicializamos el numero de das nd <- 0.
    Recibir el valor mximo de la pobacin de la colonia de bactrias Mmax.
    Dentro de un ciclo Mientras calcular el incremento a la poblcin de bacterias y sumarlo a al valor previo.
    Cuando la poblacin de bacterias alcanza el valor deseado Mmax salir del ciclo Mientras. Esto lo hacemos con una condicin.
    Mostrar el nmero de das.
    Fin del algoritmo.
    # Programa: Pobalcin de una colonia de bacteras.
    # Se calcula el nmero de das en que la pobalcin 
    # de una colonia de bacterias se duplica
    nd <- 1
    M0 <- 10
    print(" Dame la poblacin mxima ")
    Mmax <- as.integer(readline())
    while(M0 <= Mmax){
      M0 <- 2 *M0
      if(M0 <= Mmax){
        nd <- nd + 2
      }
    }
    cat("El nmero de da es ", nd, "\n")
    cat("La poblacin de bacterias es ", M0, "\n")
    # FIN
    3.3 Sentencia repeat y break
    El tercer tipo de bucle disponible en R es el bucle repeat, es semejante al bucle while pero no tiene condicin a cumplir. El bucle repeat es un bucle infinito. La nica forma de salir de un bucle repeat es utilizar la sentencia break.
    
    Sintaxis
    
    repeat {instrucciones}
    aunque suele ir en compaa de una instruccin del tipo,
    
    if (condicin) break
    
    La sentencia break causa la interrupcin inmediata del bucle. Tambin puede ir dentro de un bucle for o while.
    
    Ejemplo
    
    x0 <- 1
    tol <- 1e-8
    repeat {
      x1 <- computeEstimate()
      if(abs(x1 - x0) < tol) {
        break
      } else {
        x0 <- x1
      }
    }
    3.4 Instruccin next
    La sentencia next permite saltar a la iteracin siguiente dentro de un bucle.
    
    Ejemplo 1
    
    for(i in 1:100) {
      if(i <= 20) {
        ## Salta las 20 primeras iteraciones 
        next
      }
      ## Resto del cdigo
    }
    4 La funcin switch()
    La funcin switch() no es una estructura de control propiamente dicha, sin embargo su comportamiento la hace ser considerada dentro de las estructuras de control de flujo. Su sintaxis es,
    
    switch(expresin, item1, item2,., itemN)
    La funcin switch() evalua la expresin y en funcin del valor que tome esta devuelve un valor dentro de la lista item1, item2,., itemN. Su forma de actuar depende del tipo de datos con el que trabaja la expresin.
    
    4.1 La expresin es numrica
    El resultado de la expresin es un nmero. En este caso, el tem seleccionado es el que corresponde al mismo ndice de la lista de tem. Si el resultado de la expresin es un nmero no entero, se trunca al entero inferior.
    
    Ejemplo
    
    x <- as.integer(2)
    switch(x,1,2,3,4,5)
    ## [1] 2
    x <- 3.9
    switch(x,1,2,3,4,5)
    ## [1] 3
    Ejemplo 2 Ejemplo comprar una pizza El valor de una pizza depende de su tamao y de la cantidad de ingredientes adicionales que lleve. Los precios son: Tamao Precio 1 5??? 2 8??? 3 12???
    
    Cada ingrediente adicional cuesta 1,5???. Lea el tamao y el nmero de ingredientes y muestre el precio tatal a pagar
    
    El siguiente cdigo funciona en una sesin iteractiva pero no como parte de un archivo rmd. La solucin para comprobarlo es copiarlo en un script de R.
    
    Cdigo R
    
    entrada <- readline('Tamao de la pizza: ')
    t <- as.numeric(entrada)
    entrada <- readline('Nmero de ingredientes adicionales: ')
    n <- as.numeric(entrada)
    switch(t,
           p=5+1.5*n,
           p=8+1.5*n,
           p=12+1.5*n,
           p=0)
    cat('Total a pagar: ', p,'\n')
    4.2 La expresin es una cadena
    El resultado de la expresin es una cadena. En este caso, el tem seleccionado es el que corresponde al valor de la cadena. La lista de tems debe ser de la forma, "valor=resultadoN".
    
    Ejemplo
    
    y <- rnorm(5)
    x <- "dt"
    
    switch(x, "media"=mean(y), "mediana"=median(y), "varianza"=var(y),"dt"=sd(y),"Cadena no valida")
    ## [1] 0.553217
    x <- "DT"
    
    switch(x, "media"=mean(y), "mediana"=median(y), "varianza"=var(y),"dt"=sd(y),"Cadena no valida")
    ## [1] "Cadena no valida"
    Ejemplo 2 Da de la semana
    
    Dado un nmero entero entre 1 y 5 mostrar el da de la semana.
    
    Cdigo R
    
    d <- readline('Nmero del da ')
    switch(d,
           "1" = print('lunes'),
           "2" = print('martes'),
           "3" = print('mircoles'),
           "4" = print('jueves'),
           "5" = print('viernes'),
           "6" = print('sbado'),
           "7" = print('domingo'),
           print("Nmero no vlido"))
    5 La funcin scan()
    La funcin scan() no es una funcin de control de flujo. Sin embargo, aparece con cierta frecuencia al utilizar estas estructuras de control.
    
    La funcin scan() tiene una gran variedad de usos y volveremos sobre ella cuando veamos la lectura de ficheros de texto plano. En este momentos nos centramos en uno de sus usos.
    
    La funcin scan() permite leer datos desde la consola. Al invocarse scan() el sistema queda en espera hasta que se introducen los datos. La forma de dejar de introducir datos es introducir una lnea en blanco desde la consola ("INTRO").
    
    Ejemplo 1
    
    > datos <- scan()
    1: 22
    2: 34
    3: 67
    4: 
      Read 3 items
    Si se desea introducir un nmero predeterminado de lneas, se especifica el nmero de lneas a introducir en la opcin nmax y la opcin  multi.line=FALSE.
    
    Ejemplo 2
    
    > datos <-  scan(what=double(0),nmax=1,multi.line = FALSE)
    1: 89
    Read 1 item
    > datos
    [1] 89
    Ejemplo 3
    
    # Funcin para el calculo de la raz cuadrad de un nmero
    # si este es positivo
    FN <- function(){
      x <- scan(what=double(),nmax=1)
      if (x > 0)  {x <- sqrt(x)}
      print(x)
    }
    6 Ejercicios
    Escribir un programa que intercambie los valores de dos variables denominadas x e y.
    Escribir un programa que escriba "Hola" si el valor de la variable x es menor que 0.5 y que escriba "Adis" si x es mayor que 0.5.
    Escribir un programa que genere 1000 nmeros aleatorios (con distribucin uniforme entre 0 y 1), que cuente los que son mayores y los que son menores o iguales que 0.5 y que escriba la respuesta. [Podemos generar los 1000 nmeros aleatorios en una sola instruccin de la siguiente forma: x <- runif(1000) # Generar nmeros aleatorios
                                                                                                                                                                                                         Escribir un programa que genere los primeros cien trminos de la serie de Fibonacci.
                                                                                                                                                                                                         Calcular el cociente entre trminos consecutivos de la serie de Fibonacci y representar dichos valores. [La funcin plot() dibuja los valores del vector x]
                                                                                                                                                                                                         # Nmeros de Fibonacci
                                                                                                                                                                                                         long <- 100
                                                                                                                                                                                                         Fibonacci <- numeric(long)                     # Crea un vector fila de dimensin 100
                                                                                                                                                                                                         Fibonacci[1] <- Fibonacci[2]<- 1               # Inicializa los dos primeros elementos
                                                                                                                                                                                                         for (i in 3:long){                         # Contador i desde 3 hasta 100
                                                                                                                                                                                                           Fibonacci[i] <- Fibonacci[i-2]+Fibonacci[i-1]
                                                                                                                                                                                                         }
                                                                                                                                                                                                         print(Fibonacci)
                                                                                                                                                                                                         ##   [1] 1.000000e+00 1.000000e+00 2.000000e+00 3.000000e+00 5.000000e+00
                                                                                                                                                                                                         ##   [6] 8.000000e+00 1.300000e+01 2.100000e+01 3.400000e+01 5.500000e+01
                                                                                                                                                                                                         ##  [11] 8.900000e+01 1.440000e+02 2.330000e+02 3.770000e+02 6.100000e+02
                                                                                                                                                                                                         ##  [16] 9.870000e+02 1.597000e+03 2.584000e+03 4.181000e+03 6.765000e+03
                                                                                                                                                                                                         ##  [21] 1.094600e+04 1.771100e+04 2.865700e+04 4.636800e+04 7.502500e+04
                                                                                                                                                                                                         ##  [26] 1.213930e+05 1.964180e+05 3.178110e+05 5.142290e+05 8.320400e+05
                                                                                                                                                                                                         ##  [31] 1.346269e+06 2.178309e+06 3.524578e+06 5.702887e+06 9.227465e+06
                                                                                                                                                                                                         ##  [36] 1.493035e+07 2.415782e+07 3.908817e+07 6.324599e+07 1.023342e+08
                                                                                                                                                                                                         ##  [41] 1.655801e+08 2.679143e+08 4.334944e+08 7.014087e+08 1.134903e+09
                                                                                                                                                                                                         ##  [46] 1.836312e+09 2.971215e+09 4.807527e+09 7.778742e+09 1.258627e+10
                                                                                                                                                                                                         ##  [51] 2.036501e+10 3.295128e+10 5.331629e+10 8.626757e+10 1.395839e+11
                                                                                                                                                                                                         ##  [56] 2.258514e+11 3.654353e+11 5.912867e+11 9.567220e+11 1.548009e+12
                                                                                                                                                                                                         ##  [61] 2.504731e+12 4.052740e+12 6.557470e+12 1.061021e+13 1.716768e+13
                                                                                                                                                                                                         ##  [66] 2.777789e+13 4.494557e+13 7.272346e+13 1.176690e+14 1.903925e+14
                                                                                                                                                                                                         ##  [71] 3.080615e+14 4.984540e+14 8.065155e+14 1.304970e+15 2.111485e+15
                                                                                                                                                                                                         ##  [76] 3.416455e+15 5.527940e+15 8.944394e+15 1.447233e+16 2.341673e+16
                                                                                                                                                                                                         ##  [81] 3.788906e+16 6.130579e+16 9.919485e+16 1.605006e+17 2.596955e+17
                                                                                                                                                                                                         ##  [86] 4.201961e+17 6.798916e+17 1.100088e+18 1.779979e+18 2.880067e+18
                                                                                                                                                                                                         ##  [91] 4.660047e+18 7.540114e+18 1.220016e+19 1.974027e+19 3.194043e+19
                                                                                                                                                                                                         ##  [96] 5.168071e+19 8.362114e+19 1.353019e+20 2.189230e+20 3.542248e+20
                                                                                                                                                                                                         fib1 <- Fibonacci[1:(long-1)]
                                                                                                                                                                                                         fib2 <- Fibonacci[2:long]
                                                                                                                                                                                                         coci <- fib1/fib2
                                                                                                                                                                                                         
                                                                                                                                                                                                         plot(coci, type="l")
                                                                                                                                                                                                         
                                                                                                                                                                                                         
                                                                                                                                                                                                         Escribir un programa que genere nmeros aleatorios (con distribucin uniforme entre 0 y 1) hasta que encuentre uno que sea mayor que 0.9999 y que diga cuantos intentos ha necesitado.
                                                                                                                                                                                                         Escribir un programa que devuelva el valor medio de dos nmeros.
                                                                                                                                                                                                         Generar un vector de n nmeros aleatorios con distribucin normal y mostrar el valor mayor de todos. [rnorm(n, mean=0, sd=1) genera n nmeros aleatorios con distribucin normal de media 0 y desviacin tpica 1] max(rnorm(n=1000, mean=0, sd=1))
                                                                                                                                                                                                         7 Notas
                                                                                                                                                                                                         Para la depuracin de los script es necesario mostrar el valor de las variables intermedias, para ello hemos visto las funciones print(), show() y ahora presentaremos la funcin cat(). La funcin cat() permite unas salidas ms informativas que print() y show(). Veamos el ejemplo siguiente,
                                                                                                                                                                                                         
                                                                                                                                                                                                         Ejemplo
                                                                                                                                                                                                         
                                                                                                                                                                                                         #  Ejemplo del uso de cat()
                                                                                                                                                                                                         x <- 3
                                                                                                                                                                                                         for (i in 1:3) {
                                                                                                                                                                                                           show(x)
                                                                                                                                                                                                           cat("i= ", i , "\n")   # \n significa salto de lnea debe ir entre comillas
                                                                                                                                                                                                           if (x%% 2 == 0) {
                                                                                                                                                                                                             x <- x/2
                                                                                                                                                                                                           } else {
                                                                                                                                                                                                             x <- 3*x +1
                                                                                                                                                                                                           }
                                                                                                                                                                                                         }
                                                                                                                                                                                                         ## [1] 3
                                                                                                                                                                                                         ## i=  1 
                                                                                                                                                                                                         ## [1] 10
                                                                                                                                                                                                         ## i=  2 
                                                                                                                                                                                                         ## [1] 5
                                                                                                                                                                                                         ## i=  3
                                                                                                                                                                                                         show(x)
                                                                                                                                                                                                         ## [1] 16