1 Introduccin
El objeto bsico en R es el vector. Un vector es un objeto indexado a partir del ndice 1, que se caracteriza por contener objetos que pueden ser  numeric, integer,logical o characterpero todos del mismo tipo.

El concepto de vector en R es algo diferente a la nocin matemtica de vector. En R no existen ni vectores fila ni vectores columna. En general, un vector de R dentro de una expresin matemtica se comportar como sea necesario (vector fila o columna) para la expresin en la que se le requiere, aunque a veces hay que obligarlo. En R para referirse a un elemento de un vector el ndice se encierra entre corchetes. Por ejemplo, los elementos del vector w estn indexados de forma que w[3] hace referencia al tercer elemento del vector w.

2 Creacin de vectores
Las formas principales para crear vectores en R son dos:
  
  por asignacin
como resultado de alguna funcin.
2.1 Por asignacin
Vector de longitud 1*
  
  En el caso de asignar un nico valor se crea un vector unitario que a veces se le llama "escalar".

x <- 7
length(x)
## [1] 1
"Hola" -> y
length(y)
## [1] 1
para construir vectores de longitud mayoer que 1 se utilizan funciones.

2.2 Con funciones
Las principales funciones para crear vectores:
  
  c()
seq()
:
  rep()
2.2.1 Funcin c()
La funcin c() (combinar o concatenar) permite crear un vector escribiendo los diferentes valores que lo forman.

x <- c(1,2,3,4,5)
x
## [1] 1 2 3 4 5
length(x)
## [1] 5
vec1 <- c(1,2,3)
length(vec1)
## [1] 3
c("Hola", "Adios") -> saludos
length(saludos)
## [1] 2
2.2.2 Funcin seq()
La funcin seq()permite crear una secuencia de valores numricos (reales) desde el valor origen from al final to con un incremento de terminado por by. Su sintaxis es,

seq(from = 1, to = 1, by = ((to - from)/(length.out - 1)),
    length.out = NULL, along.with = NULL, ...)
Ejemplos

x <- seq(from = 1, to = 5, by = 1)         # El incremento por defecto es uno 
x
## [1] 1 2 3 4 5
y <- seq(1, 2, 0.1)                        # Se permiten incrementos decimales
y
##  [1] 1.0 1.1 1.2 1.3 1.4 1.5 1.6 1.7 1.8 1.9 2.0
w <- seq(from = 1, to = 2, length.out = 5) # Se especifica el nmero de elementos
w
## [1] 1.00 1.25 1.50 1.75 2.00
z <- seq(from = 7, to = -2, by = -2.5)      # Se permiten incrementos negativos decimales
z
## [1]  7.0  4.5  2.0 -0.5
Existen funciones derivadas de seq() que permiten un cdigo ms claro y rpido. Mirar ?seq.

seq.int(from, to, by, length.out, along.with, ...)
seq_along(along.with)
seq_len(length.out)
2.2.3 La funcin :
  La funcin a:b es parecida a la funcin seq() pero ms limitada. Crea una secuencia desde a hasta b con incremento de 1. El vector generado con : es de enteros. Obsrvese el resultado de estos cdigos.

Cdigo 1

# Vector 1 desde 1 hasta 5 de uno en uno clase numeric
y <- seq(from=1, to=5, by=1)
y
## [1] 1 2 3 4 5
class(y)    # numeric
## [1] "numeric"
# Vector 1 desde 1 hasta 5 de uno en uno clase entero
z <- 1:5
z
## [1] 1 2 3 4 5
class(z)    # integer
## [1] "integer"
# Sin embargo
z == y
## [1] TRUE TRUE TRUE TRUE TRUE
identical(z,y)
## [1] FALSE
La funcin : tiene la prioridad ms alta dentro de una expresin. Fijate en las siguientes expresiones.

1:10-1
##  [1] 0 1 2 3 4 5 6 7 8 9
1:(10-1)
## [1] 1 2 3 4 5 6 7 8 9
2.2.4 La funcin rep()
La funcin rep() repite el objeto x el nmero de veces determinado por el valor de la opcin times. Su sintaxis es,

rep(x, times = 1, length.out = NA, each = 1)
Ejemplo 1

x <- rep(3, times =4)
x
## [1] 3 3 3 3
class(x)
## [1] "numeric"
is.vector(x)
## [1] TRUE
y <- rep(34, length.out=4)
y
## [1] 34 34 34 34
class(y)
## [1] "numeric"
is.vector(y)
## [1] TRUE
s <- rep(c(1,2), length.out=5, each=2)
s
## [1] 1 1 2 2 1
class(s)
## [1] "numeric"
is.vector(s)
## [1] TRUE
2.2.4.1 Argumento times (admite recycling pero no entodas las ocasiones)
vec <- 1:4
rep(x = vec, times = 3)          # times toma un nico valor
##  [1] 1 2 3 4 1 2 3 4 1 2 3 4
rep(x = vec, times = c(1,2,3,4)) # times toma tanto valores como tiene el vector
##  [1] 1 2 2 3 3 3 4 4 4 4
# rep(x = vec, times = c(1,2))   # times no admite valores intermedios
2.2.4.1.1 Argumento each (no admite recycling)
rep(c(5,12,13), each=4)           # each toma un nico valor
##  [1]  5  5  5  5 12 12 12 12 13 13 13 13
rep(c(5,12,13), each=c(2,3,5))    # each toma un vector de valores
## Warning in rep(c(5, 12, 13), each = c(2, 3, 5)): first element used of
## 'each' argument
## [1]  5  5 12 12 13 13
rep(c(5,12,13), each=c(2,3))      # each toma un vector de valores
## Warning in rep(c(5, 12, 13), each = c(2, 3)): first element used of 'each'
## argument
## [1]  5  5 12 12 13 13
En R se permite la definicin de vectores sin ningn elemento,

x <- c()
length(x)   # Longitud del vector x
## [1] 0
3 Vectorizacin
Las funciones sobre vectores son en general elemento a elemento, esto es lo que se conoce como vectorizacin (en R).

Definimos dos vectores

x <- c(1, 2,3,4)
y <- c(10, 20, 30, 40)
x+y    # Suma de vectores
## [1] 11 22 33 44
x*y    # Multiplicacin elemento a elemento
## [1]  10  40  90 160
x/y    # Divisin elemento a elemento
## [1] 0.1 0.1 0.1 0.1
y^x    # Potencia elemento a elemento
## [1]      10     400   27000 2560000
Cundo se operan vectores de distinta longitud, R repite el ms corto hasta que iguala la longitud del ms largo. Este proceso se conoce como recycling.

# suma de vectores de diferente longitud
c(1,2,3,4) + c(1,2) ??? c(1,2,3,4) + c(1,2,1,2)??? 2 4 4 6
2 + c(1,3,5,7)          ??? c(2,2,2,2) + c(1,3,5,7)??? 3 5 7 9 

# Multiplicacin de vectores de diferente longitud
2 * c(1,3,5,7)      ??? c(2,2,2,2) * c(1,3,5,7)??? 2 6 10 14 

# potencia de vectores de diferente longitud 
(1:10)^2            ??? (1:10)^c(2,2,.,2) ??? 2 4 9 16 25 . 100
4 Vectores de caracteres
Un vector de caracteres es aquel en que sus valores son cadenas alfanumricas.

(Dias <- c("lunes", "martes", "mircoles", "jueves", "viernes", "sbado", "domingo")) 
## [1] "lunes"     "martes"    "mircoles" "jueves"    "viernes"   "sbado"   
## [7] "domingo"
R tiene algunos vectores de caracteres predefinidos:
  
  # Letras maysculas (alfabeto ingls)
  LETTERS
##  [1] "A" "B" "C" "D" "E" "F" "G" "H" "I" "J" "K" "L" "M" "N" "O" "P" "Q"
## [18] "R" "S" "T" "U" "V" "W" "X" "Y" "Z"
# Letras minsculas (alfabeto ingls)
letters
##  [1] "a" "b" "c" "d" "e" "f" "g" "h" "i" "j" "k" "l" "m" "n" "o" "p" "q"
## [18] "r" "s" "t" "u" "v" "w" "x" "y" "z"
# Nombre de los meses en ingls
month.name
##  [1] "January"   "February"  "March"     "April"     "May"      
##  [6] "June"      "July"      "August"    "September" "October"  
## [11] "November"  "December"
# Nombre abreviado de los meses en ingls
month.abb
##  [1] "Jan" "Feb" "Mar" "Apr" "May" "Jun" "Jul" "Aug" "Sep" "Oct" "Nov"
## [12] "Dec"
4.1 La funcin paste()
Una de las principales funciones sobre cadena de caracteres es la funcin paste(). Su sintaxis es,

paste (..., sep = " ", collapse = NULL)
paste0(..., collapse = NULL)
donde


.	uno o ms objetos de R, que sern convertidos a vectores carcter (si no lo son)
sep	carcter que servir para separar las cadenas. No est permitido NA.
collapse	fusiona todos las cadenas para crear una nica cadena final. El valor del argumento collapse es lo que se inserta entre las diferentes cadenas. No est permitido NA.
Ejemplos

# Convierte nmeros en carcteres
paste(1:12)
##  [1] "1"  "2"  "3"  "4"  "5"  "6"  "7"  "8"  "9"  "10" "11" "12"
# Une cadenas
paste("A",1:6, sep="")      #primero crea el vector A, luego crea el vector 1,2....6, despus convierte cada A en los numeros
## [1] "A1" "A2" "A3" "A4" "A5" "A6"
paste("Today is", date())
## [1] "Today is Tue Oct 04 12:06:47 2016"
paste(c("Maana","ser", "un","da","histrico"), collapse='--')
## [1] "Maana--ser--un--da--histrico"
Escribe un programa que genere la siguiente secuencia de variables consecutivas,

k1=1
k2=1+2=3
k3=1+2+3=6
k4=1+2+3+4=10
k5=1+2+3+4+5=15
for(i in 1:5){
  assign(paste("k",i,sep = ""), sum(1:i))  #asigna la k1, luego k2....asi sucesivamente
}        
k1; k2; k3; k4; k5
## [1] 1
## [1] 3
## [1] 6
## [1] 10
## [1] 15


5 Vectores lgicos
En R los vectores tambin pueden almacenar valores lgicos. Los valores lgicos en R son: TRUE (T) y FALSE (F), aunque se desaconseja el uso de las abreviaciones T y F.

Los vectores lgicos se obtienen por medio de condiciones.

Ejemplo

# Vectores lgicos
x <- 20:25 #x va de 20 a 25
x >= 19   #va a comparar elemento a elemento si x es mayor que 19
## [1] TRUE TRUE TRUE TRUE TRUE TRUE
La condicin x >= 19 se ha aplicado a cada uno de los elementos del vector x (vectorizacin). Cuando se "suma" un vector lgico los TRUE se comportan como 1 y los FALSE como 0 (coercin)

sum(x>19)
## [1] 6
Se pueden especificar ms de una condicin.

x <- 15:30
# Condicin 1: El valor de x es par
cond1 <- (x%%2 == 0)
print(cond1)
##  [1] FALSE  TRUE FALSE  TRUE FALSE  TRUE FALSE  TRUE FALSE  TRUE FALSE
## [12]  TRUE FALSE  TRUE FALSE  TRUE
# Condicin 2: El valor de x es mayor que 25
cond2 <- x>25
show(cond2)
##  [1] FALSE FALSE FALSE FALSE FALSE FALSE FALSE FALSE FALSE FALSE FALSE
## [12]  TRUE  TRUE  TRUE  TRUE  TRUE
# Que cumplan las dos condiciones
cond1 & cond2
##  [1] FALSE FALSE FALSE FALSE FALSE FALSE FALSE FALSE FALSE FALSE FALSE
## [12]  TRUE FALSE  TRUE FALSE  TRUE
x[cond1 & cond2]
## [1] 26 28 30


6 Seleccionar elementos de un vector
Hay diferentes forma de seleccionar subconjuntos de elementos de un vector. En general distinguiremos dos formar:
  
  por medio de vectores de ndices.
por medio de funciones
6.1 Vectores de ndices
Los vectores de ndices son de cuatro tipos:
  
  Vectores lgicos
Vectores de enteros positivos
Vectores de enteros negativos
Vectores de cadena
6.2 Vectores lgicos
Han de tener la misma longitud que el vector del que se quiere filtrar elementos. Los valores que corresponde a TRUE se extraen y los que corresponden a FALSE se omiten.

# Que cumplan las dos condiciones
cond1 & cond2
##  [1] FALSE FALSE FALSE FALSE FALSE FALSE FALSE FALSE FALSE FALSE FALSE
## [12]  TRUE FALSE  TRUE FALSE  TRUE
x[cond1 & cond2]
## [1] 26 28 30
6.3 Vectores de enteros positivos
Los valores que contienen deben corresponderse con los ndices del vector, es decir tiene que pertenecer al intervalo [1,length(vector)]. Los elementos correspondientes a los ndices se extraen y los ndices que no aparezcan sern omitidos.

# Vector que contiene los elementos
x <- 15:30

# Longitud del vector que tiene los elementos a ser extraidos
lon <- length(x)
cat(lon)
## 16
# Vector de indices que se quieren extrater.
indice <- c(2,3,5,8,15)

# Elementos extraidos
x[indice]
## [1] 16 17 19 22 29
6.4 Vectores de enteros negativos
Los valores que contienen deben corresponderse con los ndices del vector pero con el signo - delante, es decir tiene que pertenecer al intervalo  [ -length(vector),-1]. Los elementos correspondientes a los ndices son omitidos.

# Eliminar del vector x el tercer elemento
x[-3]
##  [1] 15 16 18 19 20 21 22 23 24 25 26 27 28 29 30
# Eliminar del vector x los elementos 1,3,6 y 7
x[-c(1,3,6,7)]
##  [1] 16 18 19 22 23 24 25 26 27 28 29 30
6.5 Vectores de cadenas
nicamente se pueden utilizar si el objeto tiene el atributo names que identifica sus elementos. En este caso un subvector de nombres se emplea de la misma forma que un vector de nmeros enteros positivos.

# Ejemplo semana
semana <- 1:7
names(semana) <- c('Domingo','Lunes','Martes','Mircoles','Jueves','Viernes','Sbado')

# Seleccionamos jueves y martes
semana[c("Jueves","Martes")]
## Jueves Martes 
##      5      3
# Ejemplos
x<-0:10
sum(x)
## [1] 55
length(x)
## [1] 11
sum(x<5)
## [1] 5
x[x<5]
## [1] 0 1 2 3 4
sum(x[x<5])
## [1] 10
length(x[x<5])
## [1] 5
sum(x*(x<5))
## [1] 10
sum(which(x<5))
## [1] 15
z<-numeric(10)
id<-which(x<5)
z[id] <- x[x<5]
z[which(x<5)] <- x[x<5] # equivalente al anterior (mejor?)
6.6 Funciones
De principio utilizaremos la funcin subset().

6.6.1 Funcin subset()
Tiene el mismo efecto que el filtrado por ndices salvo en el tratamiento de las NA

x <- c(1, 1:3, NA, 12)
x[x>5]
## [1] NA 12
subset(x, x>5)
## [1] 12
7 Coercin de tipos
La mayora de las funciones producen un error cuando el tipo de datos que esperan no coincide con los que especificamos en los argumentos.

Ante un error de este tipo disponemos de:
  
  funciones de comprobacin
funciones de coercin
Las funciones de comprobacin chequean si un objeto es de una tipo determinado. Las funciones de comprobacin comienzan por la partcula  is.*** seguida del tipo que se quiere comprobar. El resultado de este tipo de funciones es un valor lgico TRUE o FALSE.

Las funciones de coercin fuerzan a cambiar el tipo del objeto con el que se est trabajando. Las funciones de coercin comienzan por la partcula as.*** seguida del tipo al que se quiere transformar. No siempre se puede realizar la transformacin, para poder realizar una trasformacin es necesario que no se den incompatibilidad entre el tipo de datos origen y destino.

La siguiente tabla muestra los tipos ms importantes que se pueden comprobar o forzar

Tipo	Comprobacin	Coercin
array	is.array()	as.array()
character	is.character()	as.character()
complex	is.complex()	as.complex()
double	is.double()	as.double()
factor	is.factor()	as.factor()
integer	is.integer()	as.integer()
list	is.list()	as.list()
logical	is.logical()	as.logical()
matrix	is.matrix()	as.matrix()
NA	is.na()	-
  NaN	is.nan()	-
  NULL	is.null()	as.null()
numeric	is.numeric()	as.numeric()
ts	is.ts()	as.ts()
vector	is.vector()	as.vector()
Adems de estas funciones de comprobacin hay otras como is.finite().

Cuando se combinan dos tipos de datos el resultado es un dato del tipo ms general.

Por ejemplo:
  
  c(TRUE, FALSE, TRUE, FALSE)
## [1]  TRUE FALSE  TRUE FALSE
c(TRUE, FALSE, TRUE, FALSE,6L)       # Lgico y numerico entero
## [1] 1 0 1 0 6
c(TRUE, FALSE, TRUE, FALSE,6.3)      # Lgico y numerico doble
## [1] 1.0 0.0 1.0 0.0 6.3
c(TRUE, FALSE, TRUE, FALSE,4+6.3i)   # Lgico y complejo
## [1] 1+0.0i 0+0.0i 1+0.0i 0+0.0i 4+6.3i
c(TRUE, FALSE, TRUE, FALSE,"hola")   # Lgico y carcter
## [1] "TRUE"  "FALSE" "TRUE"  "FALSE" "hola"
class(c(6L, 7L, 8L))
## [1] "integer"
class(c(6L, 7L, 8L, 9))              # Entero y doble
## [1] "numeric"
class(c(6L, 7L, 8L, 9i))             # Entero y complejo
## [1] "complex"
class(c(6L, 7L, 8L, "hola"))         # Entero y carcter
## [1] "character"
class(c(6, 7, 8))
## [1] "numeric"
class(c(6, 7, 8, 1+1i))              # Doble y complejo
## [1] "complex"
class(c(6, 7, 8, "hola"))            # Doble y carcter
## [1] "character"
7.1 Valores especiales Inf, NaN y NA
En R existen tres valores especiales:
  
  Infinito Inf
No es un Nmero NaN (Not a Number)
No disponible NA (Not Available)
En R el nmero Inf es un nmero ms y se puede utilizar en cualquier clculo con las reglas usuales de la aritmtica del infinito. De esta forma operaciones como,

Ejemplos

Formas de obtener NaN (Not a Number)

# Infinito - Infinito
Inf-Inf
## [1] NaN
# Infinito/Infinito
Inf/Inf
## [1] NaN
# Logaritmo de un nmero negativo
log(-1)
## Warning in log(-1): Se han producido NaNs
## [1] NaN
En R valor NA es tratado como si fuera la nada. En R no existe la posibilidad de emplear la condicin lgica (objeto == NA), por lo que hay que utilizar la funcin is.na(). Igual ocurre con NaN. Sin embargo, NA y NaN son distintos. Obsrvese,

is.na(NaN)
## [1] TRUE
is.nan(NA)
## [1] FALSE
El valor de NA se utiliza como valor perdido dentro de R. En general cualquier operacin con NA da como resultado NA.

4+NA
## [1] NA
y <- c(3,4,5,NA)+ c(1,2,3,4)
y
## [1]  4  6  8 NA
en particular, la mayor parte de las funciones se ven afectadas ante un valor NA.

y <- c(3,4,5,NA)
mean(y)
## [1] NA
siendo necesario utilizar la opcin na.rm=TRUE para que la funcin no tome en cuenta ese valor.

y <- c(3,4,5,NA)
mean(y,na.rm=TRUE)
## [1] 4
8 Operaciones comunes entre vectores
8.1 Operaciones aritmticas y lgicas
8.1.1 Suma '+': Suma de dos o ms vectores
El operador suma (funcin suma, "+") es una operacin vectorizada y se ejecuta elemento a elemento.

"+"(2,3)
## [1] 5
2+3
## [1] 5
x <- c(1,2,4)
y <- c(5,0,-1)
x+y
## [1] 6 2 3
8.1.2 Multiplicacin de dos vectores
El operador multiplicacin ( funcin multiplicar, "*") es una operacin vectorizada y se ejecuta elemento a elemento.

# Vectores de igual longitud
x <- c(1,2,3,4)
y <- c(21,22,23,24)
x*y
## [1] 21 44 69 96
# Vectores de distinta longitud
a <- c(2,3,4)
b <- c(10, 20, 30, 40)
a*b
## Warning in a * b: longitud de objeto mayor no es mltiplo de la longitud de
## uno menor
## [1]  20  60 120  80
# Escalar por vector
a <- c(2,3,4)
2*a
## [1] 4 6 8
8.1.3 Divisin de dos vectores
El operador divisin (funcin multiplicar, "/") es una operacin vectorizada y se ejecuta elemento a elemento.

# Vectores de igual longitud
x <- c(20,24,28,40)
y <- c(2,3,4,5)
x/y
## [1] 10  8  7  8
# Vectores de distinta longitud
a <- c(20,24,28,40)
b <- c(2,3,4)
a/b
## Warning in a/b: longitud de objeto mayor no es mltiplo de la longitud de
## uno menor
## [1] 10  8  7 20
# Vector dividido por escalar
a <- c(20,24,28,40)
a/2
## [1] 10 12 14 20
8.1.4 Potenciacin de dos vectores
El operador potencia (funcin potencia, "^") es una operacin vectorizada y se ejecuta elemento a elemento.

x <- c(3,5,7)
y <- c(2,4,6)
x^y
## [1]      9    625 117649
8.2 Funciones de ordenacin de vectores
Las dos funciones para ordenar vectores son:
  
  Funcin	Descripcin
order(x, decreasing=FALSE)	devuelve las posiciones del vector ordenadas segun su contenido
order(x,y)	ordena los valores de x y, en caso de empate, utiliza los valores de y en las posiciones correspondientes. Ambos, x e y deben tener la misma longitud
sort (x, decreasing=FALSE)	devuelve el contenido del vector ordenado
rank(x)	devuelve el orden de cada posicion segun su contenido
Ejemplo

Orden de un vector

# Vector
x <- c(20,80.5,27.9,50,0)
order (x, decreasing=FALSE)   # devuelve los ndices de las posiciones del vector ordenadas segun su contenido
## [1] 5 1 3 4 2
sort (x, decreasing=FALSE)    # devuelve el contenido ordenado del vector
## [1]  0.0 20.0 27.9 50.0 80.5
rank(x)                   # devuelve el orden de los ndices de cada posicion segn su contenido
## [1] 2 5 3 4 1
Orden de dos vectores

x <- c(1,1,3:1,1:4,3)
x
##  [1] 1 1 3 2 1 1 2 3 4 3
y <- c(0,9:1)
y
##  [1] 0 9 8 7 6 5 4 3 2 1
x.ord <- order(x,y)
x.ord
##  [1]  1  6  5  2  7  4 10  8  3  9
9 Funciones de uso comn para vectores
Nombre	Descripcin
length()	longitud
sum()	suma de las componentes del vector
prod	producto de las componentes del vector
cumsum(), cumprod()	suma y producto acumulados
max(), min()	mximo y mnimo del vector
cummax(), cummin()	mximo y mnimo acumulados
sort()	ordena el vector
order()	devuelve los ndices de las posiciones del vector ordenadas segun su contenido
diff()	calcula la diferencia entre las componentes
which(x == a)	vector de los ndices de x para los cuales la comparacin es cierta
which.max()	ndice del mayor elemento
which.min()	ndice del menor elemento
range()	valores del mnimo y el mximo
mean()	promedio de los elementos
median()	mediana de los elementos
round(x,n)	redondea los elementos de x a n decimales
rank()	rango de los elementos
unique(x)	vector con las componentes de x sin repeticiones
all()	todos los elementos verifican la condicin
any()	algn elemento verifica la condicin
10 Atributos de un vector
Un objeto vector tiene los siguientes atributos

Atributo	Descripcin
length	nmero de datos
mode	tipo de datos
names	etiquetas de valores
class	clase "factor"
------	----------
  La funcin names() asigna nombres a los elementos de un vector.

semana <- 1:7
names(semana) <- c('Domingo','Lunes','Martes','Mircoles','Jueves','Viernes','Sbado')
semana
##   Domingo     Lunes    Martes Mircoles    Jueves   Viernes    Sbado 
##         1         2         3         4         5         6         7
11 Ejercicios
1.- Construya los siguientes vectores,

[2 3 4 5 6 7]
[7 6 5 4 3 2]
[2 5 8 11 14]
2.- Dado el vector siguiente, c(1:6,NA,NA,9:12), se pide:
  
  calcula en que posicin estn los valores perdidos. Pista utiliza la funcin which().
sustituye los NA por el valor 0
calcula la media del vector original y del trasformado. Son iguales?
  3.- Dados los vectores x=(1,2,6,2,23,8), y=(2,4,7,12,8,17), z=(6,8,4,12,14,5). Observa el resultado de max(x,y,z) y de pmax(x,y,z). Qu hace cada funcin?
  
  4.- Se quiere extraer los elementos ubicados en todas las posiciones multiplo de 25 de un vector de longitud 1000 proveniente de una distribucin normal con media igual a 100 y varianza igual a 100.

Nota: Utiliza la siguiente expresin para obtener el vector proveniente de una N(??=100,??2=100) x <- rnorm(1000,100,10). Lee la ayuda de la funcin rnorm() (?rnorm)

5.- Utilizado el vector x del ejercicio anterior, se quiere encontrar el elemento de x ms cercano a 108.0

x <- rnorm(1000,100,10)
x

cond1<- x-108
v<- abs(cond1)
y<- min(v)
z <- y+108
w <- which.min(v)
which.min(v) #debe estar mal

# de otra foma

x <- rnorm(1000,100,10)
x

dist<- abs(x-180)
min(dist)
which.min(dist)
x[834]



6.- Qu hace la siguiente expresin? #pregunta examen
  
  expand.grid(a=c(60, 80), p=c(100, 300), sexo=c('m','f'))
7.- Se pide:
  
  Genere un conjunto de 100 datos provenientes de una distribucin de Poisson de parmetro 10 y gurdelos en un vector llamado "datos1" (?rpois)
Calcule el mximo, mnimo, media, median y rango de datos1.
Cuntos valores distintos hay en el vector?
  Cules son los ndices del mximo y del mnimo? (En que posicin se encuentran)
Se quiere dibujar la siguiente curva,
f(x)=122???????????e???(x???3)28
Llamando y=f(x) y sabiendo que la instruccin en R para graficar la funcin es plot(x,y), realiza el dibujo (?plot).